clear all;

global n_sloc n_loc pos_M n_hap n_gam n_sgen n_gen n_int n_rout t1 t2;
global GxL GxSG;
global s_p s_h h_p h_h d;
global I W_p2 W_h2 meanW_p meanW_h R_p R_h RT_p2 RT_h2;
global FG_p FG_h;

function Res=dec2bint(arg_N, arg_n)
 Res=zeros(size(arg_N,1),arg_n);
 Res(dec2bin(arg_N,arg_n)=='1')=1;
endfunction#dec2bint

function CalculateAux
  global t1 t2 h_p h_h d;
  global n_sloc n_loc pos_M n_hap n_gam n_sgen n_gen n_int n_rout;
  global GxL GxSG;
     
  t1=10000;
  t2=10000;
  
  n_sloc=2;
  n_sloc=uint64(n_sloc);
  n_loc=n_sloc+1;
  pos_M=n_loc;
  n_hap=2^n_loc;
  n_gam=2^n_loc;
  n_sgen=2^(2*n_sloc);
  n_gen=2^(2*n_loc);
  n_int=n_loc-1;
  n_rout=2^n_int;
  
  h_p=1;
  h_h=0;#1 - in-phase, 0 - anti-phase
  d=0.5;
  
  #GxL
  Aux=[1:n_gen]'-1;
  GxL=0.5*(dec2bint(idivide(Aux,n_hap),n_loc)+dec2bint(rem(Aux,n_hap),n_loc));
  
  #GxSG
  Aux=dec2bin(Aux,2*n_loc);
  Aux(:,[n_sloc+1, 2*(n_sloc+1)])=[];
  Aux=bin2dec(Aux)+1;
  GxSG=zeros(n_gen,n_sgen);
  for i_gen=1:n_gen
    GxSG(i_gen,Aux(i_gen))=1;
  endfor
endfunction#CalculateAux
  
function CalculateW
  global I W_p2 W_h2;
  global s_p s_h h_p h_h n_sloc n_gen GxL;
  
  I=zeros(n_gen,n_gen);
  for gen_pi=1:n_gen
    Ph_p=GxL(gen_pi,1:n_sloc);
    switch h_p
      case 0
        Ph_p=floor(Ph_p);
      case 1
        Ph_p=ceil(Ph_p);  
    endswitch
    for gen_hj=1:n_gen
      Ph_h=GxL(gen_hj,1:n_sloc);
      switch h_h
        case 0
          Ph_h=floor(Ph_h);
        case 1
          Ph_h=ceil(Ph_h);  
      endswitch
      if all(Ph_p==Ph_h)
        I(gen_pi,gen_hj)=1;
      endif
    endfor
  endfor
  W_p2=[(1-s_p)*ones(n_gen,1);ones(n_gen,1)];
  W_h2=[ones(n_gen,1);(1-s_h)*ones(n_gen,1)];
endfunction#CalculateW

function Res=R(aRS00, aRS11, aRM00, aRM11);
  global d GxL n_gen n_int pos_M;
  RS3=[aRS00;(1-d)*aRS00+d*aRS11;aRS11];
  RM3=[aRM00;(1-d)*aRM00+d*aRM11;aRM11];
  RS_i0=RS_i1=zeros(n_gen,1);
  RM_i0=RM_i1=zeros(n_gen,1);
  for i=1:3
    Ind=(GxL(:,pos_M)==0.5*(i-1));
    RS_i0(Ind)=RS3(i,1);
    RM_i0(Ind)=RM3(i,1);
    RS_i1(Ind)=RS3(i,2);
    RM_i1(Ind)=RM3(i,2);
  endfor
  Res=[repmat(RS_i0,1,n_int-1) RM_i0;repmat(RS_i1,1,n_int-1) RM_i1];
endfunction#R

function Res=RT(aR)
  global n_loc n_hap n_gam n_int n_rout n_gen;
  Ind=dec2bint([1:n_rout]'-1,n_int);
  for gen=1:n_gen
    P01=[1-aR(gen,:); aR(gen,:)];
    P_Int=ones(n_rout,n_int);
    P1_RoutxGam=zeros(n_rout,n_gam);
    P2_RoutxGam=zeros(n_rout,n_gam);
    Chr_bin=[dec2bin(idivide(gen-1,n_hap),n_loc); dec2bin(rem(gen-1,n_hap),n_loc)];
    for rout=1:n_rout
      Gam1_bin=blanks(n_loc);
      Gam2_bin=blanks(n_loc);
      g1=1;
      Gam1_bin(1)=Chr_bin(g1,1);
      g2=2;
      Gam2_bin(1)=Chr_bin(g2,1);
      for int=1:n_int
        P_Int(rout,int)=P01(Ind(rout,int)+1,int);
        if (Ind(rout, int)==1)
          g1=3-g1;
          g2=3-g2;
        endif
        Gam1_bin(int+1)=Chr_bin(g1,int+1);
        Gam2_bin(int+1)=Chr_bin(g2,int+1);
      endfor#intervals
      Gam1=bin2dec(Gam1_bin)+1;
      Gam2=bin2dec(Gam2_bin)+1;
      P1_RoutxGam(rout,Gam1)=0.5;
      P2_RoutxGam(rout,Gam2)=0.5;
    endfor#routs
    P_Rout=prod(P_Int,2);
    P_RoutxGam=P1_RoutxGam+P2_RoutxGam;
    Res(gen,:)=P_Rout'*P_RoutxGam;#out
    #Res(gen,:)=kron(Res(gen,:),Res(gen,:));#self
  endfor#genotypes
endfunction#RT

function Res=FA2FG(aFA)#reshaffles alleles to genotypes global n_loc n_hap;
  global n_loc n_hap;
  F01=[1-aFA; aFA];
  Ind=dec2bint([1:n_hap]'-1,n_loc)+1;
  for hap=1:n_hap
    for loc=1:n_loc
      FL(hap,loc)=F01(Ind(hap,loc),loc);
    endfor  
    FH=prod(FL,2);
  endfor
  Res=kron(FH,FH);
endfunction#FA2FG

function Res=FSG2FG(aFSG, afM)
  global n_sloc n_sgen n_gen;
  Res=zeros(n_gen,1);
  for sgen=1:n_sgen
    Aux=dec2bin(sgen-1,2*n_sloc);
    Aux1=substr(Aux,1,n_sloc);
    Aux2=substr(Aux,n_sloc+1,n_sloc);
    #00
    Gen_bin=[Aux1 '0' Aux2 '0'];
    gen=bin2dec(Gen_bin)+1;
    Res(gen,1)=aFSG(sgen,1)*(1-afM)^2;
    #01
    Gen_bin=[Aux1 '0' Aux2 '1'];
    gen=bin2dec(Gen_bin)+1;
    Res(gen,1)=aFSG(sgen,1)*(1-afM)*afM;
    #10
    Gen_bin=[Aux1 '1' Aux2 '0'];
    gen=bin2dec(Gen_bin)+1;
    Res(gen,1)=aFSG(sgen,1)*afM*(1-afM);
    #11
    Gen_bin=[Aux1 '1' Aux2 '1'];
    gen=bin2dec(Gen_bin)+1;
    Res(gen,1)=aFSG(sgen,1)*afM^2;  
  endfor
endfunction#FSG2FG

function Res=Generation
  global I W_p2 W_h2 meanW_p meanW_h RT_p2 RT_h2 GxL n_loc n_gen;
  global FG_p FG_h;
  #Selection
  F_ph=FG_p*FG_h';
  FG_p2=[sum(F_ph.*(I==0),2);sum(F_ph.*(I==1),2)];
  FG_h2=[sum(F_ph.*(I==0),1) sum(F_ph.*(I==1),1)]';
  meanW_p=sum((FG_p2.*W_p2)(:));
  meanW_h=sum((FG_h2.*W_h2)(:));
  FG_p2=(FG_p2.*W_p2)/meanW_p;
  FG_h2=(FG_h2.*W_h2)/meanW_h;
  
  #Reproduction (outcrossing)
  FG_p=kron(FG_p2'*RT_p2,FG_p2'*RT_p2)';
  FG_h=kron(FG_h2'*RT_h2,FG_h2'*RT_h2)';
    
  #Res=[FG_p'*GxL meanW_p FG_h'*GxL meanW_h];
endfunction#Generation

function Res=Analyze
  global FG_p FG_h meanW_p meanW_h GxL GxSG n_sloc n_loc t1 t2;
  #burn-in1
  FG_p=FA2FG([0.5*ones(1,n_sloc) 0]);
  FG_h=FA2FG([0.5*ones(1,n_sloc) 0]);
  for t=1:t1
    Generation;
  endfor
  #invasion
  FG_p=FSG2FG((FG_p'*GxSG)',0.05);
  FG_h=FSG2FG((FG_h'*GxSG)',0.05);
  for t=1:t2
    Generation;
  endfor
  Res=[FG_p'*GxL meanW_p FG_h'*GxL meanW_h];
    
  #burn-in2
  FG_p=FA2FG([0.5*ones(1,n_sloc) 1]);
  FG_h=FA2FG([0.5*ones(1,n_sloc) 1]);
  for t=1:t1
    Generation;
  endfor
  #resistance
  FG_p=FSG2FG((FG_p'*GxSG)',0.95);
  FG_h=FSG2FG((FG_h'*GxSG)',0.95);
  for t=1:t2
    Generation;
  endfor
  Res=[Res;FG_p'*GxL meanW_p FG_h'*GxL meanW_h];
endfunction#Analyze

#Main
tic
CalculateAux;
fo=fopen("opt.txt", "w");
fclose(fo);

Point=load("cloud.txt");
for pt=1:size(Point,1)
  pt
  s_p=Point(pt,1);
  s_h=Point(pt,2);
  CalculateW;
  c_p=Point(pt,3);
  R_p=R([c_p c_p],[c_p c_p],[0.5 0.5],[0.5 0.5]);
  RT_p2=[RT(R_p(1:n_gen,:));RT(R_p(n_gen+1:2*n_gen,:))];
  
  K=[0.05 0.01 0.001];
  opt_inf=0;
  opt_sup=0.5;
  Opt=[];
  for i_K=1:size(K,2)
    dr=K(1,i_K);
    if opt_inf==opt_sup
      opt_inf=max(opt_inf-5*dr,0);
      opt_sup=min(opt_sup+5*dr,0.5);
    endif
       
    do#upwards
      R_h=R([opt_inf opt_inf],[opt_inf+dr opt_inf+dr],[0.5 0.5],[0.5 0.5]);
      RT_h2=[RT(R_h(1:n_gen,:));RT(R_h(n_gen+1:2*n_gen,:))];
      Dyn=Analyze;
      if Dyn(:,2*n_loc+1)-[0.05;0.95]>10^-12
        win=1;
        opt_inf=round(1000*(opt_inf+dr))/1000;
      else
        win=0;
      endif
    until (win!=1)|(opt_inf==0.5);
       
    do#downwards
      R_h=R([opt_sup opt_sup],[opt_sup-dr opt_sup-dr],[0.5 0.5],[0.5 0.5]);
      RT_h2=[RT(R_h(1:n_gen,:));RT(R_h(n_gen+1:2*n_gen,:))];
      Dyn=Analyze;
      if Dyn(:,2*n_loc+1)-[0.05;0.95]>10^-12
        win=1;
        opt_sup=round(1000*(opt_sup-dr))/1000;
      else
        win=0;
      endif
    until (win!=1)|(opt_sup==0);
    Opt=[Opt opt_inf opt_sup];
  endfor#K
  save opt.txt -append -ascii -tabs Opt;
  endfor#f
toc